# MongoDB for Python developers

[![](https://raw.githubusercontent.com/mikeckennedy/mongodb-for-python-for-developers/master/readme_resources/mongo-course-sm.jpg)](https://training.talkpython.fm/)

## Course Summary

Whether you're adding an API to an existing web application, creating a new API for a JavaScript heavy client-side app, or even building a backend service for a mobile app, this course will show you how to build RESTful services using Pyramid and integrate with a real database over SQLAlchemy.

## What students are saying

*Let me say that your courses are tremendous and I am a huge fan. I had tried a few different online learning platforms (edx, datacamp), so when I found your Python Jumpstart, I decided to finally give a paid course a try. Your courses strike an excellent balance between hand-holding and DIY, and they suit my learning style perfectly. [...] I'm a lifetime customer. Thank you for the great content, I appreciate the work you're doing. -- Josh*

## What's this course about and how is it different?

This course will teach you how to build RESTful and HTTP-based services in Python using the Pyramid web framework.

Yes, you will learn the necessary programming techniques. But we will go much deeper than just stringing together some methods in your web framework. In this course, you will

* Compare RESTful services to other services such as SOAP and sockets
* Fully understand how to leverage HTTP verbs, status codes, content types, and URLs to properly design and deliver RESTful services
* Add JSON, CSV, image, and other response types to services
* Explore and test your services using the Postman application
* Add content negotiation to allow clients to select the best response type
* Properly refactor your service code for maintainability using view models and more
* Work with SQLAlchemy as the backend for your web services
* Deploy your HTTP service for production behind NGINX and uWSGI

## Who is this course for?

Anyone who knows Python and would like to use Python to create flexible and high performance RESTful or HTTP-based web services.

Whether you need a backend for your mobile app, rich JavaScript app, or want add an API to your existing Pyramid web application, this course will teach you the concepts as well as the programming techniques to implement them.

## What will you learn in this course?

Some topics covered include.

* Setting up Python 3, Postman, and PyCharm for local development
* The concepts and principles of RESTful services
* Key building blocks of the Pyramid web framework
* Building a comprehensive service using HTTP verbs, status codes, content types, and more
* Adding content negotiation to services
* Enforce identity and authorization using API keys
* How to call your service from Python and from JavaScript
* Add CORS support for cross-site access
* The basics of SQLAlchemy for backing our services with a database
* How to add logging and production-time monitoring of errors
* Deploying your service on Linux behind NGINX and uWSGI for a full production capable deployment

## Is this course based on Python 3 or Python 2?

This course is based upon Python 3. With Python 2 going unsupported in 2020, we believe that it would be ill-advised to teach or learn Python 2.

## The time to act is now

Go beyond just learning how to build RESTful services. Deeply understand them and build better services. Register for the course at:

[https://training.talkpython.fm/courses/explore_restful_pyramid_course/creating-a-restful-http-api-with-pyramid-and-python-mega-course](https://training.talkpython.fm/courses/explore_restful_pyramid_course/creating-a-restful-http-api-with-pyramid-and-python-mega-course)

